<?php
   function blogspotomatic_pages_panel()
   {
   $blogspotomatic_Main_Settings = get_option('blogspotomatic_Main_Settings', false);
   if(isset($blogspotomatic_Main_Settings['api_key']) && $blogspotomatic_Main_Settings['api_key'] != '')
   {
   }
   else
   {
   ?>
<h1><?php echo esc_html__("You must add a Blogspot API Key before you can use this feature!", 'blogspotomatic-blogspot-post-generator');?></h1>
<?php
   return;
   }
   ?>
<div class="wp-header-end"></div>
<div class="wrap gs_popuptype_holder seo_pops">
   <div>
      <form id="myForm" method="post" action="admin.php?page=blogspotomatic_pages_panel">
         <?php
            wp_nonce_field('blogspotomatic_save_rules', '_blogspotomaticr_nonce');
            if (isset($_GET['settings-updated'])) {
            ?>
         <div>
            <p class="cr_saved_notif"><strong><?php echo esc_html__("Settings saved.", 'blogspotomatic-blogspot-post-generator');?></strong></p>
         </div>
         <?php
            }
            ?>
         <div>
            <div class="hideMain">
               <hr/>
               <div class="table-responsive">
                  <table id="mainRules" class="responsive table cr_main_table">
                     <thead>
                        <tr>
                           <th>
                              <?php echo esc_html__("ID", 'blogspotomatic-blogspot-post-generator');?>
                              <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                 <div class="bws_hidden_help_text cr_min_260px">
                                    <?php
                                       echo esc_html__("This is the ID of the rule. ", 'blogspotomatic-blogspot-post-generator');
                                       ?>
                                 </div>
                              </div>
                           </th>
                           <th>
                              <?php echo esc_html__("Blog ID or URL", 'blogspotomatic-blogspot-post-generator');?>
                              <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                 <div class="bws_hidden_help_text cr_min_260px">
                                    <?php
                                       echo esc_html__("Input the Blogspot blog Id or URL.", 'blogspotomatic-blogspot-post-generator');
                                       ?>
                                 </div>
                              </div>
                           </th>
                           <th>
                              <?php echo esc_html__("Schedule", 'blogspotomatic-blogspot-post-generator');?>
                              <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                 <div class="bws_hidden_help_text cr_min_260px">
                                    <?php
                                       echo esc_html__("Select the interval in hours after which you want this rule to run. Defined in hours.", 'blogspotomatic-blogspot-post-generator');
                                       ?>
                                 </div>
                              </div>
                           </th>
                           <th>
                              <?php echo esc_html__("Max # Posts", 'blogspotomatic-blogspot-post-generator');?>
                              <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                 <div class="bws_hidden_help_text cr_min_260px">
                                    <?php
                                       echo esc_html__("Select the maximum number of posts that this rule can create at once. 0-500 interval allowed.", 'blogspotomatic-blogspot-post-generator');
                                       ?>
                                 </div>
                              </div>
                           </th>
                           <th>
                              <?php echo esc_html__("Post Status", 'blogspotomatic-blogspot-post-generator');?>
                              <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                 <div class="bws_hidden_help_text cr_min_260px">
                                    <?php
                                       echo esc_html__("Select the status that you want for the automatically generated posts to have.", 'blogspotomatic-blogspot-post-generator');
                                       ?>
                                 </div>
                              </div>
                           </th>
                           <th>
                              <?php echo esc_html__("Item Type", 'blogspotomatic-blogspot-post-generator');?>
                              <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                 <div class="bws_hidden_help_text cr_min_260px">
                                    <?php
                                       echo esc_html__("Select the type (post/page) for your automatically generated item.", 'blogspotomatic-blogspot-post-generator');
                                       ?>
                                 </div>
                              </div>
                           </th>
                           <th>
                              <?php echo esc_html__("Post Author", 'blogspotomatic-blogspot-post-generator');?>
                              <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                 <div class="bws_hidden_help_text cr_min_260px">
                                    <?php
                                       echo esc_html__("Select the author that you want to assign for the automatically generated posts.", 'blogspotomatic-blogspot-post-generator');
                                       ?>
                                 </div>
                              </div>
                           </th>
                           <th>
                              <?php echo esc_html__("More Options", 'blogspotomatic-blogspot-post-generator');?>
                              <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                 <div class="bws_hidden_help_text cr_min_260px">
                                    <?php
                                       echo esc_html__("Shows advanced settings for this rule.", 'blogspotomatic-blogspot-post-generator');
                                       ?>
                                 </div>
                              </div>
                           </th>
                           <th class="cr_max_width_40">
                              <?php echo esc_html__("Del", 'blogspotomatic-blogspot-post-generator');?>
                              <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                 <div class="bws_hidden_help_text cr_min_260px">
                                    <?php
                                       echo esc_html__("Do you want to delete this rule?", 'blogspotomatic-blogspot-post-generator');
                                       ?>
                                 </div>
                              </div>
                           </th>
                           <th class="cr_max_55">
                              <?php echo esc_html__("Active", 'blogspotomatic-blogspot-post-generator');?>
                              <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                 <div class="bws_hidden_help_text cr_min_260px">
                                    <?php
                                       echo esc_html__("Do you want to enable this rule? You can deactivate any rule (you don't have to delete them to deactivate them).", 'blogspotomatic-blogspot-post-generator');
                                       ?>
                                 </div>
                              </div>
                              <br/>
                              <input type="checkbox" onchange="thisonChangeHandler(this)" id="exclusion">
                           </th>
                           <th class="cr_max_42">
                              <?php echo esc_html__("Info", 'blogspotomatic-blogspot-post-generator');?>
                              <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                 <div class="bws_hidden_help_text cr_min_260px">
                                    <?php
                                       echo esc_html__("The number of items (posts, pages) this rule has generated so far.", 'blogspotomatic-blogspot-post-generator');
                                       ?>
                                 </div>
                              </div>
                           </th>
                           <th class="cr_actions">
                              <?php echo esc_html__("Actions", 'blogspotomatic-blogspot-post-generator');?>
                              <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                 <div class="bws_hidden_help_text cr_min_260px">
                                    <?php
                                       echo esc_html__("Do you want to run this rule now? Note that only one instance of a rule is allowed at once.", 'blogspotomatic-blogspot-post-generator');
                                       ?>
                                 </div>
                              </div>
                           </th>
                        </tr>
                        
                     </thead>
                     <tbody>
                        <?php
                           echo blogspotomatic_expand_rules_pages();
                           ?>
                        
                        <tr>
                           <td class="cr_short_td">-</td>
                           <td class="cr_sely"><input type="text" name="blogspotomatic_pages_list[textids][]"  placeholder="Please insert a blog identifier" value="" class="cr_width_full"/></td>
                           <td class="cr_comm_td"><input type="number" step="1" min="1" name="blogspotomatic_pages_list[schedule][]" class="cr_width_60" placeholder="Select the rule schedule interval" value="24"/></td>
                           <td class="cr_comm_td"><input type="number" step="1" min="0" max="500" name="blogspotomatic_pages_list[max][]" placeholder="Select the max # of generated posts" value="10" class="cr_width_60"/></td>
                           <td class="cr_status">
                              <select id="submit_status" name="blogspotomatic_pages_list[submit_status][]" class="cr_width_70">
                                 <option value="pending"><?php echo esc_html__("Pending -> Moderate", 'blogspotomatic-blogspot-post-generator');?></option>
                                 <option value="draft"><?php echo esc_html__("Draft -> Moderate", 'blogspotomatic-blogspot-post-generator');?></option>
                                 <option value="publish" selected><?php echo esc_html__("Published", 'blogspotomatic-blogspot-post-generator');?></option>
                                 <option value="private"><?php echo esc_html__("Private", 'blogspotomatic-blogspot-post-generator');?></option>
                                 <option value="trash"><?php echo esc_html__("Trash", 'blogspotomatic-blogspot-post-generator');?></option>
                              </select>
                           </td>
                           <td class="cr_comm_td"><select id="default_type" name="blogspotomatic_pages_list[default_type][]" class="cr_width_auto">
                              <?php
                                 $is_first = true;
                                 foreach ( get_post_types( '', 'names' ) as $post_type ) {
                                    echo '<option value="' . esc_attr($post_type) . '"';
                                    if($is_first === true)
                                    {
                                        echo ' selected';
                                        $is_first = false;
                                    }
                                    echo '>' . esc_html($post_type) . '</option>';
                                 }
                                 ?>
                              </select>  
                           </td>
                           <td class="cr_author"><select id="post_author" name="blogspotomatic_pages_list[post_author][]" class="cr_width_auto cr_max_width_150">
                              <?php
                                 $blogusers = get_users( [ 'role__in' => [ 'contributor', 'author', 'editor', 'administrator' ] ] );
                                 foreach ($blogusers as $user) {
                                     echo '<option value="' . esc_html($user->ID) . '"';
                                     echo '>' . esc_html($user->display_name) . '</option>';
                                 }
                                 ?>
                              </select>  
                           </td>
                           <td class="cr_width_70">
                              <input type="button" id="mybtnfzr" value="Settings">
                              <div id="mymodalfzr" class="codemodalfzr">
                                 <div class="codemodalfzr-content">
                                    <div class="codemodalfzr-header">
                                       <span id="blogspotomatic_close" class="codeclosefzr">&times;</span>
                                       <h2><span class="cr_color_white"><?php echo esc_html__("New Rule", 'blogspotomatic-blogspot-post-generator');?></span> <?php echo esc_html__("Advanced Settings", 'blogspotomatic-blogspot-post-generator');?></h2>
                                    </div>
                                    <div class="codemodalfzr-body">
                                       <div class="table-responsive">
                                          <table class="responsive table cr_main_table_nowr">
                                             <tr>
                                                <td class="cr_min_width_200">
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("Set the title of the generated posts for user rules. You can use the following shortcodes: %%item_date%%, %%random_sentence%%, %%random_sentence2%%, %%item_title%%, %%item_description%%, %%item_content%%, %%item_cat%%, %%item_tags%%", 'blogspotomatic-blogspot-post-generator');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Generated Post Title:", 'blogspotomatic-blogspot-post-generator');?></b>&nbsp;<b><a href="https://coderevolution.ro/knowledge-base/faq/post-template-reference-advanced-usage/" target="_blank">&#9432;</a></b>
                                                </td>
                                                <td>
                                                <input type="text" name="blogspotomatic_pages_list[post_title][]" value="%%item_title%%" placeholder="Please insert your desired post title. Example: %%item_title%%" class="cr_width_full">
                                                </div>
                                                </td>
                                             </tr>
                                             <tr>
                                                <td class="cr_min_width_200">
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("Set the content of the generated posts for user rules. You can use the following shortcodes: %%item_date%%, %%item_audio_play_year%%, %%item_audio_track_number%%, %%item_audio_album%%, %%item_audio_artist%%, %%item_quote_source%%, %%item_play_count%%, %%item_asking_name%%, %%item_asking_url%%, %%item_link_author%%, %%item_link_publisher%%, %%item_link_url%%, %%item_link_excerpt%%, %%custom_html%%, %%custom_html2%%, %%random_sentence%%, %%random_sentence2%%, %%item_title%%, %%item_description%%, %%item_content%%, %%item_content_plain_text%%, %%item_image_URL%%, %%item_url%%, %%item_cat%%, %%item_tags%%, %%item_read_more_button%%, %%item_show_image%%, %%item_image_URL%%, %%author%%, %%author_link%%", 'blogspotomatic-blogspot-post-generator');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Generated Post Content:", 'blogspotomatic-blogspot-post-generator');?></b>&nbsp;<b><a href="https://coderevolution.ro/knowledge-base/faq/post-template-reference-advanced-usage/" target="_blank">&#9432;</a></b>
                                                </td>
                                                <td>
                                                <textarea rows="2" cols="70" name="blogspotomatic_pages_list[post_content][]" placeholder="Please insert your desired post content. Example:%%item_content%%" class="cr_width_full">%%item_content%%</textarea>
                                                </div>
                                                </td>
                                             </tr>
                                             <tr>
                                                <td>
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("Do you want to remember last posted item and continue search from it the next time the importing rule runs?", 'blogspotomatic-blogspot-post-generator');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Remember Last Posted Item And Continue Search From It:", 'blogspotomatic-blogspot-post-generator');?></b>
                                                </td>
                                                <td>
                                                <input type="checkbox" id="continue_search" name="blogspotomatic_pages_list[continue_search][]" checked>
                                                </div>
                                                </td>
                                             </tr>
                                             <tr>
                                                <td>
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("A specific page status. Returns the pages that fit this status. This field is optional.", 'blogspotomatic-blogspot-post-generator');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Page Status To Get:", 'blogspotomatic-blogspot-post-generator');?></b>
                                                </td>
                                                <td>
                                                <select id="post_status_get" name="blogspotomatic_pages_list[post_status_get][]" class="cr_width_full">
                                                <option value="any" selected><?php echo esc_html__("Any", 'blogspotomatic-blogspot-post-generator');?></option>
                                                <option value="live"><?php echo esc_html__("Published", 'blogspotomatic-blogspot-post-generator');?></option>
                                                <option value="draft"><?php echo esc_html__("Draft", 'blogspotomatic-blogspot-post-generator');?></option>
                                                <option value="imported"><?php echo esc_html__("Imported", 'blogspotomatic-blogspot-post-generator');?></option>
                                                </select>   
                                                </div>
                                                </td>
                                             </tr>
                                             <tr>
                                                <td>
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("Do you want to set post date as the original date from Blogspot?", 'blogspotomatic-blogspot-post-generator');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Set Post Original Date:", 'blogspotomatic-blogspot-post-generator');?></b>
                                                </td>
                                                <td>
                                                <input type="checkbox" id="original_date" name="blogspotomatic_pages_list[original_date][]">
                                                </div>
                                                </td>
                                             </tr>
                                             <tr>
                                                <td>
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("Do you want to strip images from generated content?", 'blogspotomatic-blogspot-post-generator');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Strip Images From Content:", 'blogspotomatic-blogspot-post-generator');?></b>
                                                </td>
                                                <td>
                                                <input type="checkbox" id="strip_images" name="blogspotomatic_pages_list[strip_images][]">
                                                </div>
                                                </td>
                                             </tr>
                                             <tr>
                                                <td>
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("Do you want to limit the title's lenght to a specific word count? To disable this feature, leave this field blank.", 'blogspotomatic-blogspot-post-generator');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Limit Title Word Count:", 'blogspotomatic-blogspot-post-generator');?></b>
                                                </td>
                                                <td>
                                                <input type="number" min="1" step="1" id="limit_title_word_count" name="blogspotomatic_pages_list[limit_title_word_count][]" value="" class="cr_width_full">
                                                </div>
                                                </td>
                                             </tr>
                                             <tr>
                                                <td class="cr_min_width_200">
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("If your template supports 'Post Formats', than you can select one here. If not, leave this at it's default value.", 'blogspotomatic-blogspot-post-generator');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Generated Post Format:", 'blogspotomatic-blogspot-post-generator');?></b>   
                                                </td>
                                                <td class="cr_min_width_200">
                                                <select id="post_format" name="blogspotomatic_pages_list[post_format][]" class="cr_width_full">
                                                <option value="post-format-standard"  selected><?php echo esc_html__("Standard", 'blogspotomatic-blogspot-post-generator');?></option>
                                                <option value="post-format-aside"><?php echo esc_html__("Aside", 'blogspotomatic-blogspot-post-generator');?></option>
                                                <option value="post-format-gallery"><?php echo esc_html__("Gallery", 'blogspotomatic-blogspot-post-generator');?></option>
                                                <option value="post-format-link"><?php echo esc_html__("Link", 'blogspotomatic-blogspot-post-generator');?></option>
                                                <option value="post-format-image"><?php echo esc_html__("Image", 'blogspotomatic-blogspot-post-generator');?></option>
                                                <option value="post-format-quote"><?php echo esc_html__("Quote", 'blogspotomatic-blogspot-post-generator');?></option>
                                                <option value="post-format-status"><?php echo esc_html__("Status", 'blogspotomatic-blogspot-post-generator');?></option>
                                                <option value="post-format-video"><?php echo esc_html__("Video", 'blogspotomatic-blogspot-post-generator');?></option>
                                                <option value="post-format-audio"><?php echo esc_html__("Audio", 'blogspotomatic-blogspot-post-generator');?></option>
                                                <option value="post-format-chat"><?php echo esc_html__("Chat", 'blogspotomatic-blogspot-post-generator');?></option>
                                                </select>     
                                                </div>
                                                </td>
                                             </tr>
                                             <tr>
                                                <td class="cr_min_width_200">
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("Select the post category that you want for the automatically generated posts to have.", 'blogspotomatic-blogspot-post-generator');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Additional Post Category:", 'blogspotomatic-blogspot-post-generator');?></b>
                                                </td>
                                                <td>
                                                <select id="default_category" name="blogspotomatic_pages_list[default_category][]" class="cr_width_full">
                                                <option value="blogspotomatic_no_category_12345678" selected><?php echo esc_html__("Do Not Add a Category", 'blogspotomatic-blogspot-post-generator');?></option>
                                                <?php
                                                   $cat_args   = array(
                                                       'orderby' => 'name',
                                                       'hide_empty' => 0,
                                                       'order' => 'ASC'
                                                   );
                                                   $categories = get_categories($cat_args);
                                                   foreach ($categories as $category) {
                                                   ?>
                                                <option value="<?php
                                                   echo esc_html($category->term_id);
                                                   ?>"><?php
                                                   echo esc_html(sanitize_text_field($category->name));
                                                   ?></option>
                                                <?php
                                                   }
                                                   ?>
                                                </select>     
                                                </div>
                                                </td>
                                             </tr>
                                             <tr>
                                                <td>
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("Do you want to automatically add post categories from the Blogspot items?", 'blogspotomatic-blogspot-post-generator');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Auto Add Categories:", 'blogspotomatic-blogspot-post-generator');?></b>
                                                </td>
                                                <td>
                                                <select class="cr_width_full" id="auto_categories" name="blogspotomatic_pages_list[auto_categories][]">
                                                <option value="disabled" selected><?php echo esc_html__("Disabled", 'blogspotomatic-blogspot-post-generator');?></option>
                                                <option value="tags"><?php echo esc_html__("Post Tags", 'blogspotomatic-blogspot-post-generator');?></option>
                                                <option value="content"><?php echo esc_html__("Content", 'blogspotomatic-blogspot-post-generator');?></option>
                                                <option value="both"><?php echo esc_html__("Post Tags and Content", 'blogspotomatic-blogspot-post-generator');?></option>
                                                </select>                         
                                                </div>
                                                </td>
                                             </tr>
                                             <tr>
                                                <td>
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("Do you want to automatically add post tags from the Blogspot items?", 'blogspotomatic-blogspot-post-generator');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Auto Add Tags:", 'blogspotomatic-blogspot-post-generator');?></b>
                                                </td>
                                                <td>
                                                <select class="cr_width_full" id="auto_tags" name="blogspotomatic_pages_list[auto_tags][]">
                                                <option value="disabled" selected><?php echo esc_html__("Disabled", 'blogspotomatic-blogspot-post-generator');?></option>
                                                <option value="tags"><?php echo esc_html__("Post Tags", 'blogspotomatic-blogspot-post-generator');?></option>
                                                <option value="content"><?php echo esc_html__("Content", 'blogspotomatic-blogspot-post-generator');?></option>
                                                <option value="both"><?php echo esc_html__("Post Tags and Content", 'blogspotomatic-blogspot-post-generator');?></option> 
                                                </select>                    
                                                </div>
                                                </td>
                                             </tr>
                                             <tr>
                                                <td>
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("Select the post tags that you want for the automatically generated posts to have.", 'blogspotomatic-blogspot-post-generator');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Additional Post Tags:", 'blogspotomatic-blogspot-post-generator');?></b>
                                                </td>
                                                <td>
                                                <input type="text" name="blogspotomatic_pages_list[default_tags][]" value="" placeholder="Please insert your additional post tags here" class="cr_width_full">
                                                </div>
                                                </td>
                                             </tr>
                                             <tr>
                                                <td>
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("Do you want to enable comments for the generated posts?", 'blogspotomatic-blogspot-post-generator');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Enable Comments For Posts:", 'blogspotomatic-blogspot-post-generator');?></b>
                                                </td>
                                                <td>
                                                <input type="checkbox" id="enable_comments" name="blogspotomatic_pages_list[enable_comments][]" checked>
                                                </div>
                                                </td>
                                             </tr>
                                             <tr>
                                                <td>
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("Do you want to enable pingbacks/trackbacks for the generated posts?", 'blogspotomatic-blogspot-post-generator');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Enable Pingback/Trackback:", 'blogspotomatic-blogspot-post-generator');?></b>
                                                </td>
                                                <td>
                                                <input type="checkbox" id="enable_pingback" name="blogspotomatic_pages_list[enable_pingback][]" checked>
                                                </div>
                                                </td>
                                             </tr>
                                             <tr>
                                                <td>
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("Do you want to set featured image for generated post (to the first image that was found in the post)?", 'blogspotomatic-blogspot-post-generator');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Auto Get Featured Image:", 'blogspotomatic-blogspot-post-generator');?></b>
                                                </td>
                                                <td>
                                                <input type="checkbox" id="featured_image" name="blogspotomatic_pages_list[featured_image][]" checked>
                                                </div>
                                                </td>
                                             </tr>
                                             <tr>
                                                <td>
                                                   <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                      <div class="bws_hidden_help_text cr_min_260px">
                                                         <?php
                                                            echo esc_html__("Insert a comma separated list of links to valid images that will be set randomly for the featured image for the posts that do not have a valid image attached or if you disabled automatical featured image generation. You can also use image numeric IDs from images found in the Media Gallery. To disable this feature, leave this field blank.", 'blogspotomatic-blogspot-post-generator');
                                                            ?>
                                                      </div>
                                                   </div>
                                                   <b><?php echo esc_html__("Default Featured Image List:", 'blogspotomatic-blogspot-post-generator');?></b>
                                                </td>
                                                <td>
                                                   <input class="cr_width_60p" type="text" name="blogspotomatic_pages_list[image_url][]" placeholder="Please insert the link to a valid image" id="cr_input_box"  value=""/>
                                                   <input class="cr_width_33p blogspotomatic_image_button" type="button" value=">>>"/>
                                                </td>
                                             </tr>
                                             <tr>
                                                <td>
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text" class="cr_min_360">
                                                            <?php
                                                               echo esc_html__("Do you want to automatically generate post comments from item's comments feed?", 'blogspotomatic-blogspot-post-generator');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Import Comments:", 'blogspotomatic-blogspot-post-generator');?></b>
                                                   </div>
                                                </td>
                                                <td>
                                                   <div>
                                                      <select id="auto_generate_comments" name="blogspotomatic_pages_list[auto_generate_comments][]" class="cr_width_full">
                                                         <option value="0" selected><?php echo esc_html__("Do Not Import Comments", 'blogspotomatic-blogspot-post-generator');?></option>
                                                         <?php
                                                            for ($i = 1; $i <= 50; $i++) {
                                                                echo '<option value="' . esc_attr($i) . '">' . esc_html($i) . '</option>';
                                                            }
                                                            ?>
                                                         <option value="99999"><?php echo esc_html__("All", 'blogspotomatic-blogspot-post-generator');?></option>
                                                      </select>
                                                   </div>
                                                </td>
                                             </tr>
                                          </table>
                                       </div>
                                    </div>
                                    <div class="codemodalfzr-footer">
                                       <br/>
                                       <h3 class="cr_inline">Blogspotomatic Automatic Post Generator</h3>
                                       <span id="blogspotomatic_ok" class="codeokfzr cr_inline">OK&nbsp;</span>
                                       <br/><br/>
                                    </div>
                                 </div>
                              </div>
                           </td>
                           <td class="cr_shrt_td2"><span class="cr_gray20">X</span></td>
                           <td class="cr_short_td"><input type="checkbox" name="blogspotomatic_pages_list[active][]" value="1" checked />
                              <input type="hidden" name="blogspotomatic_pages_list[last_run][]" value="1988-01-27 00:00:00"/>
                           </td>
                           <td class="cr_short_td">
                              <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                 <div class="bws_hidden_help_text cr_min_260px">
                                    <?php
                                       echo esc_html__("No info.", 'blogspotomatic-blogspot-post-generator');
                                       ?>
                                 </div>
                              </div>
                           </td>
                           <td class="cr_center">
                              <div>
                                 <img src="<?php
                                    echo esc_url(plugin_dir_url(dirname(__FILE__)) . 'images/running.gif');
                                    ?>" alt="Running" class="cr_running">
                                 <div class="codemainfzr cr_gray_back">
                                    <select id="actions" class="actions" name="actions" disabled>
                                       <option value="select" disabled selected><?php echo esc_html__("Select an Action", 'blogspotomatic-blogspot-post-generator');?></option>
                                       <option value="run" onclick=""><?php echo esc_html__("Run This Rule Now", 'blogspotomatic-blogspot-post-generator');?></option>
                                       <option value="trash" onclick=""><?php echo esc_html__("Move All Posts To Trash", 'blogspotomatic-blogspot-post-generator');?></option>
                                       <option value="delete" onclick=""><?php echo esc_html__("Permanently Delete All Posts", 'blogspotomatic-blogspot-post-generator');?></option>
                                    </select>
                                 </div>
                              </div>
                           </td>
                        </tr>
                     </tbody>
                  </table>
               </div>
            </div>
         </div>
         <hr/>
         <div>
            <p class="submit"><input type="submit" name="btnSubmit" id="btnSubmit" class="button button-primary" onclick="unsaved = false;" value="<?php echo esc_html__("Save Settings", 'blogspotomatic-blogspot-post-generator');?>"/></p>
         </div>
         <div>
            <a href="https://www.youtube.com/watch?v=5rbnu_uis7Y" target="_blank"><?php echo esc_html__("Nested Shortcodes also supported!", 'blogspotomatic-blogspot-post-generator');?></a><br/><?php echo esc_html__("Confused about rule running status icons?", 'blogspotomatic-blogspot-post-generator');?> <a href="http://coderevolution.ro/knowledge-base/faq/how-to-interpret-the-rule-running-visual-indicators-red-x-yellow-diamond-green-tick-from-inside-plugins/" target="_blank"><?php echo esc_html__("More info", 'blogspotomatic-blogspot-post-generator');?></a><br/>
            <div class="cr_none" id="midas_icons">
               <table>
                  <tr>
                     <td><img id="run_img" src="<?php echo esc_url(plugin_dir_url(dirname(__FILE__)) . 'images/running.gif');?>" alt="Running" title="status"></td>
                     <td><?php echo esc_html__("In Progress", 'blogspotomatic-blogspot-post-generator');?> - <b><?php echo esc_html__("Importing is Running", 'blogspotomatic-blogspot-post-generator');?></b></td>
                  </tr>
                  <tr>
                     <td><img id="ok_img" src="<?php echo esc_url(plugin_dir_url(dirname(__FILE__)) . 'images/ok.gif');?>" alt="OK"  title="status"></td>
                     <td><?php echo esc_html__("Success", 'blogspotomatic-blogspot-post-generator');?> - <b><?php echo esc_html__("New Posts Created", 'blogspotomatic-blogspot-post-generator');?></b></td>
                  </tr>
                  <tr>
                     <td><img id="fail_img" src="<?php echo esc_url(plugin_dir_url(dirname(__FILE__)) . 'images/failed.gif');?>" alt="Faield" title="status"></td>
                     <td><?php echo esc_html__("Failed", 'blogspotomatic-blogspot-post-generator');?> - <b><?php echo esc_html__("An Error Occurred.", 'blogspotomatic-blogspot-post-generator');?> <b><?php echo esc_html__("Please check 'Activity and Logging' plugin menu for details.", 'blogspotomatic-blogspot-post-generator');?></b></td>
                  </tr>
                  <tr>
                     <td><img id="nochange_img" src="<?php echo esc_url(plugin_dir_url(dirname(__FILE__)) . 'images/nochange.gif');?>" alt="NoChange" title="status"></td>
                     <td><?php echo esc_html__("No Change - No New Posts Created", 'blogspotomatic-blogspot-post-generator');?> - <b><?php echo esc_html__("Possible reasons:", 'blogspotomatic-blogspot-post-generator');?></b></td>
                  </tr>
                  <tr>
                     <td></td>
                     <td>
                        <ul>
                           <li>&#9658; <?php echo esc_html__("Already all posts are published that match your search and posts will be posted when new content will be available", 'blogspotomatic-blogspot-post-generator');?></li>
                           <li>&#9658; <?php echo esc_html__("Some restrictions you defined in the plugin's 'Main Settings'", 'blogspotomatic-blogspot-post-generator');?> <i>(<?php echo esc_html__("example: 'Minimum Content Word Count', 'Maximum Content Word Count', 'Minimum Title Word Count', 'Maximum Title Word Count', 'Banned Words List', 'Reuired Words List', 'Skip Posts Without Images'", 'blogspotomatic-blogspot-post-generator');?>)</i> <?php echo esc_html__("prevent posting of new posts.", 'blogspotomatic-blogspot-post-generator');?></li>
                        </ul>
                     </td>
                  </tr>
               </table>
            </div>
         </div>
      </form>
   </div>
</div>
<?php
   }
   if (isset($_POST['blogspotomatic_pages_list'])) {
       add_action('admin_init', 'blogspotomatic_save_rules_pages');
   }
   
   function blogspotomatic_save_rules_pages($data2)
   {
       check_admin_referer('blogspotomatic_save_rules', '_blogspotomaticr_nonce');
       
       $data2 = $_POST['blogspotomatic_pages_list'];
       $rules = array();
       $cont  = 0;
       if (isset($data2['textids'][0])) {
           for ($i = 0; $i < sizeof($data2['textids']); ++$i) {
               $bundle = array();
               if (isset($data2['schedule'][$i]) && $data2['schedule'][$i] != '' && $data2['textids'][$i] != '') {
                   $bundle[] = trim(sanitize_text_field($data2['textids'][$i]));
                   $bundle[] = trim(sanitize_text_field($data2['schedule'][$i]));
                   if (isset($data2['active'][$i])) {
                       $bundle[] = trim(sanitize_text_field($data2['active'][$i]));
                   } else {
                       $bundle[] = '0';
                   }
                   $bundle[]     = trim(sanitize_text_field($data2['last_run'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['max'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['submit_status'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['default_type'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['post_author'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['default_tags'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['default_category'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['auto_categories'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['auto_tags'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['enable_comments'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['featured_image'][$i]));
                   $bundle[]     = trim($data2['image_url'][$i]);
                   $bundle[]     = $data2['post_title'][$i];
                   $bundle[]     = $data2['post_content'][$i];
                   $bundle[]     = trim(sanitize_text_field($data2['enable_pingback'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['post_format'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['auto_generate_comments'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['strip_images'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['limit_title_word_count'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['original_date'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['post_status_get'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['continue_search'][$i]));
                   $rules[$cont] = $bundle;
                   $cont++;
               }
           }
       }
       update_option('blogspotomatic_pages_list', $rules, false);
   }
   function blogspotomatic_expand_rules_pages()
   {
       $cat_args   = array(
                   "orderby" => "name",
                   "hide_empty" => 0,
                   "order" => "ASC"
       );
       $categories = get_categories($cat_args);
       if (!get_option('blogspotomatic_running_list')) {
           $running = array();
       } else {
           $running = get_option('blogspotomatic_running_list');
       }
       $GLOBALS['wp_object_cache']->delete('blogspotomatic_pages_list', 'options');
       $rules  = get_option('blogspotomatic_pages_list');
       $output = '';
       $cont   = 0;
       if (!empty($rules)) {
           $posted_items = array();
           $post_list = array();
           $postsPerPage = 50000;
           $paged = 0;
           do
           {
               $postOffset = $paged * $postsPerPage;
               $query = array(
                   'post_status' => array(
                       'publish',
                       'draft',
                       'pending',
                       'trash',
                       'private',
                       'future'
                   ),
                   'post_type' => array(
                       'any'
                   ),
                   'numberposts' => $postsPerPage,
                   'meta_key' => 'blogspotomatic_parent_rule',
                   'fields' => 'ids',
                   'offset'  => $postOffset
               );
               $got_me = get_posts($query);
               $post_list = array_merge($post_list, $got_me);
               $paged++;
           }while(!empty($got_me));
           wp_suspend_cache_addition(true);
           foreach ($post_list as $post) {
               $rule_id = get_post_meta($post, 'blogspotomatic_parent_rule', true);
               if ($rule_id != '') {
                   $exp = explode('-', $rule_id);
                   if(isset($exp[0]) && isset($exp[1]) && $exp[0] == '2')
                   {
                       $posted_items[] = $exp[1];
                   }
               }
           }
           wp_suspend_cache_addition(false);
           $counted_vals = array_count_values($posted_items);
           foreach ($rules as $request => $bundle[]) {
               if (isset($counted_vals[$cont])) {
                   $generated_posts = $counted_vals[$cont];
               } else {
                   $generated_posts = 0;
               }
               $bundle_values          = array_values($bundle);
               $myValues               = $bundle_values[$cont];
               $array_my_values        = array_values($myValues);for($iji=0;$iji<count($array_my_values);++$iji){if(is_string($array_my_values[$iji])){$array_my_values[$iji]=stripslashes($array_my_values[$iji]);}}
               $textids                    = $array_my_values[0];
               $schedule               = $array_my_values[1];
               $active                 = $array_my_values[2];
               $last_run               = $array_my_values[3];
               $max                    = $array_my_values[4];
               $status                 = $array_my_values[5];
               $def_type               = $array_my_values[6];
               $post_user_name         = $array_my_values[7];
               $default_tags           = $array_my_values[8];
               $default_category       = $array_my_values[9];
               $auto_categories        = $array_my_values[10];
               $auto_tags              = $array_my_values[11];
               $enable_comments        = $array_my_values[12];
               $featured_image         = $array_my_values[13];
               $image_url              = $array_my_values[14];
               $post_title             = $array_my_values[15];
               $post_content           = $array_my_values[16];
               $enable_pingback        = $array_my_values[17];
               $post_format            = $array_my_values[18];
               $auto_generate_comments = $array_my_values[19];
               $strip_images           = $array_my_values[20];
               $limit_title_word_count = $array_my_values[21];
               $original_date          = $array_my_values[22];
               $post_status_get        = $array_my_values[23];
               $continue_search        = $array_my_values[24];
               $output .= '<tr>
                           <td class="cr_short_td">' . esc_html($cont) . '</td>
   						<td class="cr_sely"><input type="text" placeholder="Please insert a blog identifier" name="blogspotomatic_pages_list[textids][]" value="' . esc_attr($textids) . '" class="cr_width_full" required></td>
                           <td class="cr_comm_td"><input type="number" step="1" min="1" placeholder="# h" name="blogspotomatic_pages_list[schedule][]" value="' . esc_attr($schedule) . '" class="cr_width_60" required></td>
                           <td class="cr_comm_td"><input type="number" step="1" min="0" placeholder="# max" max="500" name="blogspotomatic_pages_list[max][]" value="' . esc_attr($max) . '"  class="cr_width_60" required></td>
                           <td class="cr_status"><select id="submit_status" name="blogspotomatic_pages_list[submit_status][]" class="cr_width_70">
                                     <option value="pending"';
               if ($status == 'pending') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Pending -> Moderate", 'blogspotomatic-blogspot-post-generator') . '</option>
                                     <option value="draft"';
               if ($status == 'draft') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Draft -> Moderate", 'blogspotomatic-blogspot-post-generator') . '</option>
                                     <option value="publish"';
               if ($status == 'publish') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Published", 'blogspotomatic-blogspot-post-generator') . '</option>
                                     <option value="private"';
               if ($status == 'private') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Private", 'blogspotomatic-blogspot-post-generator') . '</option>
                                     <option value="trash"';
               if ($status == 'trash') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Trash", 'blogspotomatic-blogspot-post-generator') . '</option>
                       </select>  </td>
                       <td class="cr_comm_td"><select id="default_type" name="blogspotomatic_pages_list[default_type][]" class="cr_width_auto">';
               foreach ( get_post_types( '', 'names' ) as $post_type ) {
                  $output .= '<option value="' . esc_attr($post_type) . '"';
                  if ($def_type == $post_type) {
                       $output .= ' selected';
                   }
                  $output .= '>' . esc_html($post_type) . '</option>';
               }
               $output .= '</select>  </td>
                       <td class="cr_author"><select id="post_author" name="blogspotomatic_pages_list[post_author][]" class="cr_width_auto cr_max_width_150">';
               $blogusers = get_users( [ 'role__in' => [ 'contributor', 'author', 'editor', 'administrator' ] ] );
               foreach ($blogusers as $user) {
                   $output .= '<option value="' . esc_html($user->ID) . '"';
                   if ($post_user_name == $user->ID) {
                       $output .= " selected";
                   }
                   $output .= '>' . esc_html($user->display_name) . '</option>';
               }
               $output .= '</select>  </td>
                       <td class="cr_width_70">
                       <input type="button" id="mybtnfzr' . esc_html($cont) . '" value="Settings">
                       <div id="mymodalfzr' . esc_html($cont) . '" class="codemodalfzr">
     <div class="codemodalfzr-content">
       <div class="codemodalfzr-header">
         <span id="blogspotomatic_close' . esc_html($cont) . '" class="codeclosefzr">&times;</span>
         <h2>' . esc_html__('Rule', 'blogspotomatic-blogspot-post-generator') . ' <span class="cr_color_white">ID ' . esc_html($cont) . '</span> ' . esc_html__('Advanced Settings', 'blogspotomatic-blogspot-post-generator') . '</h2>
       </div>
       <div class="codemodalfzr-body">
       <div class="table-responsive">
         <table class="responsive table cr_main_table_nowr">
       <tr><td class="cr_min_width_200">
       <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Set the title of the generated posts for user rules. You can use the following shortcodes:  %%item_date%%, %%random_sentence%%, %%random_sentence2%%, %%item_title%%, %%item_description%%, %%item_content%%, %%item_cat%%, %%item_tags%%", 'blogspotomatic-blogspot-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Generated Post Title", 'blogspotomatic-blogspot-post-generator') . ':</b>&nbsp;<b><a href="https://coderevolution.ro/knowledge-base/faq/post-template-reference-advanced-usage/" target="_blank">&#9432;</a></b>
                       
                       </td><td>
                       <input type="text" name="blogspotomatic_pages_list[post_title][]" value="' . esc_attr(htmlspecialchars($post_title)) . '" placeholder="Please insert your desired post title. Example: %%item_title%%" class="cr_width_full">
                           
           </div>
           </td></tr><tr><td class="cr_min_width_200">
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Set the content of the generated posts for user rules. You can use the following shortcodes: %%item_date%%, %%item_audio_play_year%%, %%item_audio_track_number%%, %%item_audio_album%%, %%item_audio_artist%%, %%item_quote_source%%, %%item_play_count%%, %%item_asking_name%%, %%item_asking_url%%, %%item_link_author%%, %%item_link_publisher%%, %%item_link_url%%, %%item_link_excerpt%%, %%custom_html%%, %%custom_html2%%, %%random_sentence%%, %%random_sentence2%%, %%item_title%%, %%item_description%%, %%item_content%%, %%item_content_plain_text%%, %%item_image_URL%%, %%item_url%%, %%item_cat%%, %%item_tags%%, %%item_read_more_button%%, %%item_show_image%%, %%item_image_URL%%, %%author%%, %%author_link%%", 'blogspotomatic-blogspot-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Generated Post Content", 'blogspotomatic-blogspot-post-generator') . ':</b>&nbsp;<b><a href="https://coderevolution.ro/knowledge-base/faq/post-template-reference-advanced-usage/" target="_blank">&#9432;</a></b>
                       
                       </td><td>
                       <textarea rows="2" cols="70" name="blogspotomatic_pages_list[post_content][]" placeholder="Please insert your desired post content. Example:%%item_content%%" class="cr_width_full">' . htmlspecialchars($post_content) . '</textarea>
                           
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Do you want to remember last posted item and continue search from it the next time the importing rule runs?", 'blogspotomatic-blogspot-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Remember Last Posted Item And Continue Search From It", 'blogspotomatic-blogspot-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="checkbox" id="continue_search" name="blogspotomatic_pages_list[continue_search][]"';
               if ($continue_search == '1') {
                   $output .= ' checked';
               }
               $output .= '>
                           
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("A specific page status. Returns the pages that fit this status. This field is optional.", 'blogspotomatic-blogspot-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Page Status To Get", 'blogspotomatic-blogspot-post-generator') . ':</b>
                       
                       </td><td>
                       <select id="post_status_get" name="blogspotomatic_pages_list[post_status_get][]" class="cr_width_full">
                       <option value="any"';
               if ($post_status_get == 'any') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Any", 'blogspotomatic-blogspot-post-generator') . '</option>
                       <option value="live"';
               if ($post_status_get == 'live') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Published", 'blogspotomatic-blogspot-post-generator') . '</option>
                       <option value="draft"';
               if ($post_status_get == 'draft') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Draft", 'blogspotomatic-blogspot-post-generator') . '</option>
                       <option value="imported"';
               if ($post_status_get == 'imported') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Imported", 'blogspotomatic-blogspot-post-generator') . '</option>
                   </select>   
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Do you want to set post date as the original date from Blogspot?", 'blogspotomatic-blogspot-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Set Post Original Date", 'blogspotomatic-blogspot-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="checkbox" id="original_date" name="blogspotomatic_pages_list[original_date][]"';
               if ($original_date == '1') {
                   $output .= ' checked';
               }
               $output .= '>
                           
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Do you want to strip images from generated content?", 'blogspotomatic-blogspot-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Strip Images From Content", 'blogspotomatic-blogspot-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="checkbox" id="strip_images" name="blogspotomatic_pages_list[strip_images][]"';
               if ($strip_images == '1') {
                   $output .= ' checked';
               }
               $output .= '>
                           
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Do you want to limit the title\'s lenght to a specific word count? To disable this feature, leave this field blank.", 'blogspotomatic-blogspot-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Limit Title Word Count", 'blogspotomatic-blogspot-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="number" min="1" step="1" id="limit_title_word_count" name="blogspotomatic_pages_list[limit_title_word_count][]" value="' . esc_attr($limit_title_word_count) . '" class="cr_width_full">
                           
           </div>
           </td></tr><tr><td class="cr_min_width_200">
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__('If your template supports "Post Formats", than you can select one here. If not, leave this at it\'s default value.', 'blogspotomatic-blogspot-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Generated Post Format", 'blogspotomatic-blogspot-post-generator') . ':</b>   
                       </td><td>
                       <select id="post_format" name="blogspotomatic_pages_list[post_format][]" class="cr_width_full">
                       <option value="post-format-standard"';
               if ($post_format == 'post-format-standard') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Standard", 'blogspotomatic-blogspot-post-generator') . '</option>
                       <option value="post-format-aside"';
               if ($post_format == 'post-format-aside') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Aside", 'blogspotomatic-blogspot-post-generator') . '</option>
                       <option value="post-format-gallery"';
               if ($post_format == 'post-format-gallery') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Gallery", 'blogspotomatic-blogspot-post-generator') . '</option>
                       <option value="post-format-link"';
               if ($post_format == 'post-format-link') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Link", 'blogspotomatic-blogspot-post-generator') . '</option>
                       <option value="post-format-image"';
               if ($post_format == 'post-format-image') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Image", 'blogspotomatic-blogspot-post-generator') . '</option>
                       <option value="post-format-quote"';
               if ($post_format == 'post-format-quote') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Quote", 'blogspotomatic-blogspot-post-generator') . '</option>
                       <option value="post-format-status"';
               if ($post_format == 'post-format-status') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Status", 'blogspotomatic-blogspot-post-generator') . '</option>
                       <option value="post-format-video"';
               if ($post_format == 'post-format-video') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Video", 'blogspotomatic-blogspot-post-generator') . '</option>
                       <option value="post-format-audio"';
               if ($post_format == 'post-format-audio') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Audio", 'blogspotomatic-blogspot-post-generator') . '</option>
                       <option value="post-format-chat"';
               if ($post_format == 'post-format-chat') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Chat", 'blogspotomatic-blogspot-post-generator') . '</option>
                   </select>     
           </div>
           </td></tr><tr><td class="cr_min_width_200">
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Select the post category that you want for the automatically generated posts to have.", 'blogspotomatic-blogspot-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Additional Post Category", 'blogspotomatic-blogspot-post-generator') . ':</b>
                       
                       </td><td>
                       <select class="cr_width_full" id="default_category" name="blogspotomatic_pages_list[default_category][]">
                       <option value="blogspotomatic_no_category_12345678">' . esc_html__("Do Not Add a Category", 'blogspotomatic-blogspot-post-generator') . '</option>';
               foreach ($categories as $category) {
                   $output .= '<option value="' . esc_attr($category->term_id) . '"';
                   if ($category->term_id == $default_category) {
                       $output .= ' selected';
                   }
                   $output .= '>' . sanitize_text_field($category->name) . '</option>';
               }
               $output .= '</select>     
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Do you want to automatically add post categories from the feed items?", 'blogspotomatic-blogspot-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Auto Add Categories", 'blogspotomatic-blogspot-post-generator') . ':</b>
                       
                       </td><td>
                       <select class="cr_width_full" id="auto_categories" name="blogspotomatic_pages_list[auto_categories][]">
                       <option value="disabled"';
               if ($auto_categories == 'disabled') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Disabled", 'blogspotomatic-blogspot-post-generator') . '</option>
                       <option value="tags"';
               if ($auto_categories == 'tags') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Post Tags", 'blogspotomatic-blogspot-post-generator') . '</option>
                       <option value="content"';
               if ($auto_categories == 'content') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Content", 'blogspotomatic-blogspot-post-generator') . '</option>
                       <option value="both"';
               if ($auto_categories == 'both') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Post Tags and Content", 'blogspotomatic-blogspot-post-generator') . '</option>
                       </select>                
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Do you want to automatically add post tags from the feed items?", 'blogspotomatic-blogspot-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Auto Add Tags", 'blogspotomatic-blogspot-post-generator') . ':</b>
                       
                       </td><td>
                       <select class="cr_width_full" id="auto_tags" name="blogspotomatic_pages_list[auto_tags][]">
                       <option value="disabled"';
               if ($auto_tags == 'disabled') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Disabled", 'blogspotomatic-blogspot-post-generator') . '</option>
                       <option value="tags"';
               if ($auto_tags == 'tags') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Post Tags", 'blogspotomatic-blogspot-post-generator') . '</option>
                       <option value="content"';
               if ($auto_tags == 'content') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Content", 'blogspotomatic-blogspot-post-generator') . '</option>
                       <option value="both"';
               if ($auto_tags == 'both') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Post Tags and Content", 'blogspotomatic-blogspot-post-generator') . '</option>
                       </select>            
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Select the post tags that you want for the automatically generated posts to have.", 'blogspotomatic-blogspot-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Additional Post Tags", 'blogspotomatic-blogspot-post-generator') . ':</b>
                       
                       </td><td>
                       <input class="cr_width_full" type="text" name="blogspotomatic_pages_list[default_tags][]" value="' . esc_attr($default_tags) . '" placeholder="Please insert your additional post tags here" >
                           
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Do you want to enable comments for the generated posts?", 'blogspotomatic-blogspot-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Enable Comments For Posts", 'blogspotomatic-blogspot-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="checkbox" id="enable_comments" name="blogspotomatic_pages_list[enable_comments][]"';
               if ($enable_comments == '1') {
                   $output .= ' checked';
               }
               $output .= '>
                           
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Do you want to enable pingbacks and trackbacks for the generated posts?", 'blogspotomatic-blogspot-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Enable Pingback/Trackback", 'blogspotomatic-blogspot-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="checkbox" id="enable_pingback" name="blogspotomatic_pages_list[enable_pingback][]"';
               if ($enable_pingback == '1') {
                   $output .= ' checked';
               }
               $output .= '>
                           
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Do you want to set featured image for generated post (to the first image that was found in the post)?", 'blogspotomatic-blogspot-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Auto Get Featured Image", 'blogspotomatic-blogspot-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="checkbox" id="featured_image" name="blogspotomatic_pages_list[featured_image][]"';
               if ($featured_image == '1') {
                   $output .= ' checked';
               }
               $output .= '>
                           
           </div>
           </td></tr><tr><td>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Insert a comma separated list of links to valid images that will be set randomly for the featured image for the posts that do not have a valid image attached or if you disabled automatical featured image generation. You can also use image numeric IDs from images found in the Media Gallery. To disable this feature, leave this field blank.", 'blogspotomatic-blogspot-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Default Featured Image List", 'blogspotomatic-blogspot-post-generator') . ':</b>
                       </td><td>
                       <input class="cr_width_full" type="text" name="blogspotomatic_pages_list[image_url][]" placeholder="Please insert the link to a valid image" value="' . esc_attr($image_url) . '"/>
                       
           </td></tr><tr><td>
           <div class="hideComm">
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text" class="cr_min_360">' . esc_html__('Do you want to automatically generate post comments from item\'s comments feed?', 'blogspotomatic-blogspot-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Import Comments", 'blogspotomatic-blogspot-post-generator') . ':</b>
                       </div>
                       </td><td>
                       <div class="hideComm">
                       <select id="auto_generate_comments" name="blogspotomatic_pages_list[auto_generate_comments][]" class="cr_width_full">
                       <option value="0"';
               if ($auto_generate_comments == '0') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Do Not Import Comments", 'blogspotomatic-blogspot-post-generator') . '</option>';
               for ($i = 1; $i <= 50; $i++) {
                   $output .= '<option value="' . esc_attr($i) . '"';
                   if ($auto_generate_comments == $i) {
                       $output .= ' selected';
                   }
                   $output .= '>' . esc_html($i) . '</option>';
               }
               $output .= '<option value="99999"';
               if ($auto_generate_comments == '99999') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("All", 'blogspotomatic-blogspot-post-generator') . '</option></select>
                           
           </div>
           </td></tr></table></div> 
       </div>
       <div class="codemodalfzr-footer">
         <br/>
         <h3 class="cr_inline">Blogspotomatic Automatic Post Generator</h3><span id="blogspotomatic_ok' . esc_html($cont) . '" class="codeokfzr cr_inline">OK&nbsp;</span>
         <br/><br/>
       </div>
     </div>
   
   </div> 
                       </td>
   						<td class="cr_shrt_td2"><span class="wpblogspotomatic-delete">X</span></td>
                           <td class="cr_short_td"><input type="checkbox" name="blogspotomatic_pages_list[active][]" class="activateDeactivateClass" value="1"';
               if (isset($active) && $active === '1') {
                   $output .= ' checked';
               }
               $output .= '/>
                           <input type="hidden" name="blogspotomatic_pages_list[last_run][]" value="' . esc_attr($last_run) . '"/></td>
                           <td class="cr_shrt_td2"><div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                           <div class="bws_hidden_help_text cr_min_260px">' . sprintf( wp_kses( __( 'Shortcode for this rule<br/>(to cross-post from this plugin in other plugins):', 'blogspotomatic-blogspot-post-generator'), array(  'br' => array( ) ) ) ) . '<br/><b>%%blogspotomatic_2_' . esc_html($cont) . '%%</b><br/>' . esc_html__('Posts Generated:', 'blogspotomatic-blogspot-post-generator') . ' ' . esc_html($generated_posts) . '<br/>';
               if ($generated_posts != 0) {
                   $output .= '<a href="' . get_admin_url() . 'edit.php?coderevolution_post_source=Blogspotomatic_2_' . esc_html($cont) . '&post_type=' . esc_html($def_type) . '" target="_blank">' . esc_html__('View Generated Posts', 'blogspotomatic-blogspot-post-generator') . '</a><br/>';
               }
               $output .= esc_html__('Last Run: ', 'blogspotomatic-blogspot-post-generator');
               if ($last_run == '1988-01-27 00:00:00') {
                   $output .= 'Never';
               } else {
                   $output .= $last_run;
               }
               $output .= '<br/>' . esc_html__('Next Run: ', 'blogspotomatic-blogspot-post-generator');
               $nextrun = blogspotomatic_add_hour($last_run, $schedule);
               $now     = blogspotomatic_get_date_now();
               if ( defined( 'DISABLE_WP_CRON' ) && DISABLE_WP_CRON ) {
                   $output .= esc_html__('WP-CRON Disabled. Rules will not automatically run!', 'blogspotomatic-blogspot-post-generator');
               }
               else
               {
                   if (isset($active) && $active === '1') {
                       $blogspotomatic_hour_diff = (int) blogspotomatic_hour_diff($now, $nextrun);
                       if ($blogspotomatic_hour_diff >= 0) {
                           $append = 'Now.';
                           $cron   = _get_cron_array();
                           if ($cron != FALSE) {
                               $date_format = _x('Y-m-d H:i:s', 'Date Time Format1', 'blogspotomatic-blogspot-post-generator');
                               foreach ($cron as $timestamp => $cronhooks) {
                                   foreach ((array) $cronhooks as $hook => $events) {
                                       if ($hook == 'blogspotomaticaction') {
                                           foreach ((array) $events as $key => $event) {
                                               $append = date_i18n($date_format, $timestamp);
                                           }
                                       }
                                   }
                               }
                           }
                           $output .= $append;
                       } else {
                           $output .= $nextrun;
                       }
                   } else {
                       $output .= esc_html__('Rule Disabled', 'blogspotomatic-blogspot-post-generator');
                   }
               }
               $output .= '<br/>' . esc_html__('Local Time: ', 'blogspotomatic-blogspot-post-generator') . $now;
               $output .= '</div>
                       </div></td>
                           <td class="cr_center">
                           <div>
                           <img id="run_img' . esc_html($cont) . '" src="' . plugin_dir_url(dirname(__FILE__)) . 'images/running.gif' . '" alt="Running" class="cr_status_icon';
               if (!empty($running)) {
                   if (!in_array(array($cont => 2), $running)) {
                       $output .= ' cr_hidden';
                   }
                   else
                   {
                       $f = fopen(get_temp_dir() . 'blogspotomatic_2_' . $cont, 'w');
                       if($f !== false)
                       {
                           if (!flock($f, LOCK_EX | LOCK_NB)) {
                           }
                           else
                           {
                               $output .= ' cr_hidden';
                               flock($f, LOCK_UN);
                               if (($xxkey = array_search(array($cont => 2), $running)) !== false) {
                                   unset($running[$xxkey]);
                                   update_option('blogspotomatic_running_list', $running);
                               }
                           }
                       }
                   }
               } else {
                   $output .= ' cr_hidden';
               }
               $output .= '" title="status">
                           <div class="codemainfzr">
                           <select id="actions" class="actions" name="actions" onchange="actionsChangedManual(' . esc_html($cont) . ', this.value, 2);" onfocus="this.selectedIndex = 0;">
                               <option value="select" disabled selected>' . esc_html__("Select an Action", 'blogspotomatic-blogspot-post-generator') . '</option>
                               <option value="run">' . esc_html__("Run This Rule Now", 'blogspotomatic-blogspot-post-generator') . '</option>
                               <option value="trash">' . esc_html__("Move All Posts To Trash", 'blogspotomatic-blogspot-post-generator') . '</option>
                               <option value="delete">' . esc_html__("Permanently Delete All Posts", 'blogspotomatic-blogspot-post-generator') . '</option>
                           </select>
                           </div>
                           </div>
                           </td>
   					</tr>	
   					';
               $cont = $cont + 1;
           }
       }
       return $output;
   }
   ?>